Name: openCryptoki
Summary: Implementation of Cryptoki v2.11 for IBM Crypto Hardware
Version: 2.2.4
Release: 25%{?dist}
License: Other License(s), see package
Group: Productivity/Security
Source: opencryptoki-%{version}.tar.bz2
Source1: pkcsslotd.init
Source2: pkcs11_startup.sh
Source3: pkcs_slot.sh
Patch1: openCryptoki-2.2.4-ica_s390_stdll.patch
Patch2: openCryptoki-2.2.4-configure_in.patch
Patch3: openCryptoki-2.2.5-cca_stdll.patch
Patch4: openCryptoki-2.2.4-spin_lock.patch
Patch5: openCryptoki-2.2.5-s390_ica_fallback.patch
Patch6: openCryptoki-2.2.4-trousers.patch
Patch7: openCryptoki-2.2.4-cca-dlopen.patch
Patch8: openCryptoki-2.2.4-memcmp.patch
Patch9: openCryptoki-2.2.4-double_free.patch
# https://bugzilla.redhat.com/show_bug.cgi?id=538879
Patch10: openCryptoki-2.2.4-aes.patch
# https://bugzilla.redhat.com/show_bug.cgi?id=539168
Patch11: openCryptoki-2.2.4-digest.patch
# https://bugzilla.redhat.com/show_bug.cgi?id=541028
Patch12: openCryptoki-2.2.4-setup-without-hw-card.patch
# https://bugzilla.redhat.com/show_bug.cgi?id=612274
Patch13: openCryptoki-2.2.4-session_performance.patch
Url: http://oss.software.ibm.com/developerworks/opensource/opencryptoki
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
PreReq: shadow-utils coreutils sed
BuildRequires: openssl-devel >= 0.9.8a-5, trousers-devel
BuildRequires: autoconf, automake, libtool
%ifarch s390 s390x
BuildRequires: libica-devel >= 1.3.7
%endif
ExcludeArch: ia64

%description
The PKCS#11 Version 2.11 api implemented for the IBM Crypto cards.
This package includes support for the IBM 4758 Cryptographic
CoProcessor (with the PKCS#11 firmware loaded) and the IBM eServer
Cryptographic Accelerator (FC 4960 on pSeries)

%ifnarch s390
%package devel
Group: Development/Libraries
Summary: The development environment for openCryptoki package
Requires: %{name} = %{version}-%{release}
%ifarch s390x x86_64 ppc64
Requires: libopencryptoki.so.0()(64bit)  
%else
Requires: libopencryptoki.so.0
%endif

%description devel
The openCryptoki-devel package contains the development libraries and
header files for use with the openCryptoki based application
%endif

%prep
%setup -q -n opencryptoki-%{version}
%patch1 -p1 -b .ica_s390_stdll
%patch2 -p1 -b .configure_in
%patch3 -p1 -b .cca_stdll
%patch4 -p1 -b .spin_lock
%patch5 -p1 -b .s390_ica_fallback
%patch6 -p1 -b .trousers
%patch7 -p1 -b .cca-dlopen
%patch8 -p1 -b .memcmp
%patch9 -p1 -b .double_free
%patch10 -p1 -b .aes
%patch11 -p1 -b .digest
%patch12 -p1 -b .no-hw-card
%patch13 -p1 -b .session-perf

%build
autoreconf --force --install
%configure --enable-tpmtok
make

%install
# according to the stuff, / can not be build root... So
# if build root is set, then we can muck with it
if [[ $RPM_BUILD_ROOT  ]] ;
then
	rm -rf $RPM_BUILD_ROOT
	mkdir -p $RPM_BUILD_ROOT
fi
make install DESTDIR=$RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/ld.so.conf.d
mv $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d/opencryptoki.conf $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d/opencryptoki-%{_target}.conf
mv $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d/opencryptoki-stdll.conf $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d/opencryptoki-stdll-%{_target}.conf

# Do special none s390 stuff
%ifnarch s390
mkdir -p $RPM_BUILD_ROOT/usr/include/opencryptoki
cp -a usr/include/pkcs11/{apiclient.h,pkcs11.h,pkcs11types.h} $RPM_BUILD_ROOT/usr/include/opencryptoki

# Install initscript
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d
install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/pkcsslotd
%endif

# Create etc/pkcs11 and set the permissions correctly
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/pkcs11

# Remove unwated cruft
rm -rf $RPM_BUILD_ROOT/usr/src
rm -rf $RPM_BUILD_ROOT/var/tmp/*
rm -rf  $RPM_BUILD_ROOT/%{_includedir}/pkcs11/Makefile*

# Remove development lib from s390 package as we don't package it.
%ifarch s390
rm -rf $RPM_BUILD_ROOT/%{_libdir}/*.so
%endif

# Fix fileconflicts on x86 multilib system (i386/x86_64)
%ifarch %{ix86}
mv -f $RPM_BUILD_ROOT%{_sbindir}/pkcs11_startup $RPM_BUILD_ROOT%{_sbindir}/pkcs11_startup.32
install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{_sbindir}/pkcs11_startup
mv -f $RPM_BUILD_ROOT%{_sbindir}/pkcs_slot $RPM_BUILD_ROOT%{_sbindir}/pkcs_slot.32
install -m 755 %{SOURCE3} $RPM_BUILD_ROOT%{_sbindir}/pkcs_slot
%endif

%ifarch x86_64
mv -f $RPM_BUILD_ROOT%{_sbindir}/pkcs11_startup $RPM_BUILD_ROOT%{_sbindir}/pkcs11_startup.64
install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{_sbindir}/pkcs11_startup
mv -f $RPM_BUILD_ROOT%{_sbindir}/pkcs_slot $RPM_BUILD_ROOT%{_sbindir}/pkcs_slot.64
install -m 755 %{SOURCE3} $RPM_BUILD_ROOT%{_sbindir}/pkcs_slot
%endif

%postun -p /sbin/ldconfig

%post -p /sbin/ldconfig

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%pre
# Make sure that on installs or updates if libdir/pkcs11/methods and
# libdir/pkcs11/stdll # are directories they are removed prior to installation
# as rpm can't handle the transition from directories to symlinks without
# problems.
[ -d '%{_libdir}/pkcs11/methods' ] && rm -rf %{_libdir}/pkcs11/methods
[ -d '%{_libdir}/pkcs11/stdll' ] && rm -rf %{_libdir}/pkcs11/stdll

/usr/sbin/groupadd -r pkcs11 2>/dev/null || true
/usr/sbin/usermod -G $(/usr/bin/id --groups --name root | /bin/sed -e '
# add the pkcs group if it is missing
/(^| )pkcs11( |$)/!s/$/ pkcs11/
# replace spaces by commas
y/ /,/
'),pkcs11  root

%files
%defattr(-,root,root)
%ifnarch s390
%{_sysconfdir}/rc.d/init.d/pkcsslotd
%{_sbindir}/*
%doc FAQ README doc/*
%endif
%ifarch s390 s390x
%doc usr/lib/pkcs11/cca_stdll/README-IBM_CCA_users
%endif
%doc LICENSE
%{_sysconfdir}/ld.so.conf.d/*
%{_libdir}/*.so.*
%{_libdir}/opencryptoki
%{_libdir}/pkcs11

%ifnarch s390
%files devel
%defattr(-,root,root)
%{_includedir}/*
%{_libdir}/*.so
%endif


%changelog
* Thu Dec 10 2012 Eddy Nigg <eddy_nigg@startcom.org>
- Rebuild for StartCom Linux 5.0.x

* Tue Aug 24 2010 Dan Horák <dhorak@redhat.com> 2.2.4-25.el5
- fixed session/object performance degradation (#612274)
- Resolves: #612274

* Tue Dec  8 2009 Dan Horák <dhorak@redhat.com> 2.2.4-24.el5
- fixed CCA token not being recognized properly (#541028)
- Resolves: #541028

* Mon Nov 23 2009 Dan Horák <dhorak@redhat.com> 2.2.4-23.el5
- fixed CKR_TEMPLATE_INCOMPLETE exception on an unwrap of an AES key (#538879)
- fixed MAC computing during offload of MAC-hashing to CPACF using PKCS11 (#539168)
- Resolves: #538879, #539168

* Sun Sep 14 2008 Phil Knirsch <pknirsch@redhat.com> 2.2.4-22.el5
- Fixed memcmp problem for pkcsconf validation of PINs (#415931)
- Fixed double free problem in key store (#435462)

* Tue Apr 08 2008 Phil Knirsch <pknirsch@redhat.com> 2.2.4-21.el5
- Fix System Z CCA token dependent library (#440032)

* Mon Mar 31 2008 Phil Knirsch <pknirsch@redhat.com> 2.2.4-20.el5
- Added missing buildrequires and configure option for TPM (#184786)

* Thu Jan 17 2008 Phil Knirsch <pknirsch@redhat.com> 2.2.4-19.el5
- Added TPM support to openCryptoki (#184786)

* Tue Jan 15 2008 Phil Knirsch <pknirsch@redhat.com> 2.2.4-18.el5
- Fixed pkcs11_startup for zSeries (#373271)

* Mon Jan 14 2008 Phil Knirsch <pknirsch@redhat.com> 2.2.4-17.el5
- Added the CCA STDLL for s390(x) arch (#253059)
- Fixed a file descriptor leak for spin locks (#371021)

* Mon Jun 25 2007 Phil Knirsch <pknirsch@redhat.com> 2.2.4-16.el5
- Fixed bug in initscript (#222627)

* Tue Jan 16 2007 Phil Knirsch <pknirsch@redhat.com> 2.2.4-15.el5
- Fixed fileconflict problem (#222709)

* Fri Dec 15 2006 Phil Knirsch <pknirsch@redhat.com> 2.2.4-14.el5
- Final fix for the pkcsslotd initscript (#219142)

* Thu Dec 14 2006 Phil Knirsch <pknirsch@redhat.com> - 2.2.4-13.el5
- Fixed pkcsslotd initscript for non zSeries archs (#219142)

* Thu Dec 14 2006 Phil Knirsch <pknirsch@redhat.com> - 2.2.4-12.el5
- Moved the .so lib to the devel package (#219242)
- Added proper multilib requirements for devel package (#219242)

* Wed Dec 13 2006 Phil Knirsch <pknirsch@redhat.com> - 2.2.4-11.el5
- Fixed update problem from previous releases (#215628)

* Tue Nov 28 2006 Phil Knirsch <pknirsch@redhat.com> - 2.2.4-10.el5
- Added missing post and postun ldconfig calls (#208039)

* Tue Nov 28 2006 Phil Knirsch <pknirsch@redhat.com> - 2.2.4-9.el5
- One last change to get rid of an unneeded dependancy (#208039)

* Tue Nov 07 2006 Phil Knirsch <pknirsch@redhat.com> 2.2.4-8.el5
- Made final adjustments to the packages as per IBM (#205313)

* Thu Oct 12 2006 Phil Knirsch <pknirsch@redhat.com> - 2.2.4-7.el5
- Fixed remaining problems of files according to bugzilla #208039

* Fri Sep 29 2006 Phil Knirsch <pknirsch@redhat.com> - 2.2.4-6.el5
- Included bugfix to avoid segfaults on s390(x) (#184631 comment #20)

* Fri Sep 08 2006 Phil Knirsch <pknirsch@redhat.com> - 2.2.4-5.el5
- Added the other archs according to #184631
- Split out the devel parts of openCryptoki in a devel subpackage (#184631)

* Thu Aug 31 2006 Phil Knirsch <pknirsch@redhat.com> - 2.2.4-4.el5
- Fixed dependency problems (#204680)

* Fri Jul 14 2006 Tim Powers <timp@redhat.com> - 2.2.4-2.el5
- rebuild

* Wed Jul 05 2006 Phil Knirsch <pknirsch@redhat.com> - 2.2.4-1.rhel5.1
- Initial build for RHEL5

* Fri May 12 2006 Phil Knirsch <pknirsch@redhat.com> - 2.2.4-1
- Updated to opencryptoki-2.2.4 (#184631)

* Thu Feb 09 2006 Phil Knirsch <pknirsch@redhat.com> - 2.1.6-3
- Updated openssl-devel buildprereq as we need a new version.

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> - 2.1.6-2.2
- rebuilt for new gcc4.1 snapshot and glibc changes

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Wed Nov 09 2005 Phil Knirsch <pknirsch@redhat.com> 2.1.6-rc2.2
- Rebuilt to link against latest openssl lib

* Fri Oct 21 2005 Phil Knirsch <pknirsch@redhat.com> 2.1.6-rc2.1
- Update to openCryptoki-2.1.6-rc2

* Tue Sep 06 2005 Phil Knirsch <pknirsch@redhat.com> 2.1.5-6.10
- Fixed quite a few warnings and actual errors (#143768)
- Fixed the initscript for failed startups (#154495)

* Wed Mar 02 2005 Phil Knirsch <pknirsch@redhat.com> 2.1.5-6.9
- bump release and rebuild with gcc 4

* Mon Sep 27 2004 Phil Knirsch <pknirsch@redhat.com> 2.1.5-6.8
- Fixed segfault for service status check of pkcsslotd (#133091)

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Tue Jun 15 2004 Phil Knirsch <pknirsch@redhat.com> 2.1.5-6.1
- Updated to latest upstream version openCryptoki-2.1.5-6.tar.bz2

* Tue May 11 2004 Phil Knirsch <pknirsch@redhat.com> 2.1.5-2
- Added requires for 32bit packages for 64bit package.

* Wed Apr 07 2004 Phil Knirsch <pknirsch@redhat.com>
- Update to latest version from IBM which includes important fixes (#119363)
- Create pkcs11 group.

* Thu Mar 25 2004 Tim Powers <timp@redhat.com> 2.1.3-12
- rebuilt to fix broken deps

* Tue Mar 16 2004 Phil Knirsch <pknirsch@redhat.com> 2.1.3-11
- rebuilt

* Thu Mar 04 2004 Phil Knirsch <pknirsch@redhat.com> 2.1.3-10
- Converted initsc
ript to UNIX file format, was in DOS.

* Wed Mar 03 2004 Phil Knirsch <pknirsch@redhat.com> 2.1.3-9
- Minor fixes to pkcsslotd initscript.
- Really fixed permissions this time for initscript.

* Thu Feb 26 2004 Phil Knirsch <pknirsch@redhat.com> 2.1.3-8
- Included updated initscript from IBM (#112542).
- Changed permission of /etc/init.d/pkcsslotd to be executable (#112542).

* Sat Feb 21 2004 Florian La Roche <Florian.LaRoche@redhat.de>
- mv /etc/init.d -> /etc/rc.d/init.d

* Thu Feb 19 2004 Phil Knirsch <pknirsch@redhat.com> 2.1.3-7
- rebuilt

* Wed Feb 18 2004 Phil Knirsch <pknirsch@redhat.com>  2.1.3-6
- Fixed small bug in files section.

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Wed Feb 11 2004 Phil Knirsch <pknirsch@redhat.com> 2.1.3-4
- Fixed some smaller build problems.
- Included and fixed new initscript for pkcs11 startup.
- Fixed filelist.

* Thu Jan 15 2004 Phil Knirsch <pknirsch@redhat.com> 2.1.3-3
- rebuilt

* Thu Jan 15 2004 Phil Knirsch <pknirsch@redhat.com> 2.1.3-2
- Fixed missing defattr (#113343).

* Tue Nov 11 2003 Phil Knirsch <pknirsch@redhat.com> 2.1.3-1
- Initial Red Hat package.
